Merge branches 'x86/amd', 'x86/vt-d', 'arm/rockchip', 'arm/omap', 'arm/mediatek'...
[linux-2.6-block.git] / scripts / kconfig / Makefile
CommitLineData
b2441318 1# SPDX-License-Identifier: GPL-2.0
1da177e4
LT
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
1cba0c30 6PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
281c9dad 7 localmodconfig localyesconfig
1da177e4 8
61bee204
AV
9ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
838a2e55 12Kconfig := Kconfig
61bee204 13endif
e703f75d 14
0a1f00a1
MM
15ifeq ($(quiet),silent_)
16silent := -s
17endif
18
c2838e6e
YM
19# We need this, in case the user has it in its environment
20unexport CONFIG_
21
1da177e4 22xconfig: $(obj)/qconf
0a1f00a1 23 $< $(silent) $(Kconfig)
1da177e4
LT
24
25gconfig: $(obj)/gconf
0a1f00a1 26 $< $(silent) $(Kconfig)
1da177e4
LT
27
28menuconfig: $(obj)/mconf
0a1f00a1 29 $< $(silent) $(Kconfig)
1da177e4
LT
30
31config: $(obj)/conf
0a1f00a1 32 $< $(silent) --oldaskconfig $(Kconfig)
1da177e4 33
692d97c3 34nconfig: $(obj)/nconf
0a1f00a1 35 $< $(silent) $(Kconfig)
692d97c3 36
cedd55d4
MH
37# This has become an internal implementation detail and is now deprecated
38# for external use.
1da177e4 39silentoldconfig: $(obj)/conf
9815594a 40 $(Q)mkdir -p include/config include/generated
d3fc425e
NP
41 $(Q)test -e include/generated/autoksyms.h || \
42 touch include/generated/autoksyms.h
0a1f00a1 43 $< $(silent) --$@ $(Kconfig)
1da177e4 44
50bce3e8 45localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
9815594a 46 $(Q)mkdir -p include/config include/generated
22d550ae 47 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
7a996d3a 48 $(Q)if [ -f .config ]; then \
4062f1a4
SR
49 cmp -s .tmp.config .config || \
50 (mv -f .config .config.old.1; \
51 mv -f .tmp.config .config; \
0a1f00a1 52 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
4062f1a4
SR
53 mv -f .config.old.1 .config.old) \
54 else \
55 mv -f .tmp.config .config; \
0a1f00a1 56 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
a7c02602 57 fi
03fa25da
SR
58 $(Q)rm -f .tmp.config
59
1020026f 60# Create new linux.pot file
b70e325c 61# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
46d26319 62update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
0a1f00a1 63 $(Q)$(kecho) " GEN config.pot"
a24a1b8e
PF
64 $(Q)xgettext --default-domain=linux \
65 --add-comments --keyword=_ --keyword=N_ \
66 --from-code=UTF-8 \
67 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
68 --directory=$(srctree) --directory=$(objtree) \
b70e325c
SR
69 --output $(obj)/config.pot
70 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
fa0ad657
PB
71 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
72 $(srctree)/arch/*/um/Kconfig`; \
1020026f 73 do \
0a1f00a1 74 $(kecho) " GEN $$i"; \
4217516e 75 $(obj)/kxgettext $$i \
1020026f
EG
76 >> $(obj)/config.pot; \
77 done )
0a1f00a1 78 $(Q)$(kecho) " GEN linux.pot"
1020026f 79 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
b70e325c 80 --output $(obj)/linux.pot
b70e325c 81 $(Q)rm -f $(obj)/config.pot
3b9fa093 82
1cba0c30
MM
83# These targets map 1:1 to the commandline options of 'conf'
84simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
85 alldefconfig randconfig listnewconfig olddefconfig
86PHONY += $(simple-targets)
1da177e4 87
1cba0c30 88$(simple-targets): $(obj)/conf
0a1f00a1 89 $< $(silent) --$@ $(Kconfig)
1da177e4 90
1cba0c30 91PHONY += oldnoconfig savedefconfig defconfig
1da177e4 92
fb16d891 93# oldnoconfig is an alias of olddefconfig, because people already are dependent
39c3f1ba 94# on its behavior (sets new symbols to their default value but not 'n') with the
fb16d891 95# counter-intuitive name.
1cba0c30 96oldnoconfig: olddefconfig
312ee687
MY
97 @echo " WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
98 @echo " Please use \"olddefconfig\" instead, which is an alias."
fb16d891 99
7cf3d73b 100savedefconfig: $(obj)/conf
0a1f00a1 101 $< $(silent) --$@=defconfig $(Kconfig)
7cf3d73b 102
1da177e4
LT
103defconfig: $(obj)/conf
104ifeq ($(KBUILD_DEFCONFIG),)
0a1f00a1 105 $< $(silent) --defconfig $(Kconfig)
42f9d3c6
JB
106else
107ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
0a1f00a1
MM
108 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
109 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
d2036f30
ME
110else
111 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
112 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
1da177e4 113endif
42f9d3c6 114endif
1da177e4
LT
115
116%_defconfig: $(obj)/conf
0a1f00a1 117 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
1da177e4 118
63a91033 119configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
3aaefce1 120
63a91033
MY
121%.config: $(obj)/conf
122 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
123 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
124 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
3aaefce1
JT
125
126PHONY += kvmconfig
63a91033
MY
127kvmconfig: kvm_guest.config
128 @:
3aaefce1 129
6c668505
LR
130PHONY += xenconfig
131xenconfig: xen.config
132 @:
133
0da1d4a0 134PHONY += tinyconfig
63a91033
MY
135tinyconfig:
136 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
0da1d4a0 137
1da177e4
LT
138# Help text used by make help
139help:
140 @echo ' config - Update current config utilising a line-oriented program'
fa75a727
GU
141 @echo ' nconfig - Update current config utilising a ncurses menu based'
142 @echo ' program'
1da177e4 143 @echo ' menuconfig - Update current config utilising a menu based program'
092373c2 144 @echo ' xconfig - Update current config utilising a Qt based front-end'
39c3f1ba 145 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
1da177e4 146 @echo ' oldconfig - Update current config utilising a provided .config as base'
03fa25da 147 @echo ' localmodconfig - Update current config disabling modules not loaded'
281c9dad 148 @echo ' localyesconfig - Update current config converting local mods to core'
0748cb3e 149 @echo ' defconfig - New config with default from ARCH supplied defconfig'
7cf3d73b 150 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
e11f0496 151 @echo ' allnoconfig - New config where all options are answered with no'
0748cb3e
SR
152 @echo ' allyesconfig - New config where all options are accepted with yes'
153 @echo ' allmodconfig - New config selecting modules when possible'
154 @echo ' alldefconfig - New config with all symbols set to default'
155 @echo ' randconfig - New config with random answer to all options'
861b4ea4 156 @echo ' listnewconfig - List new options'
cedd55d4
MH
157 @echo ' olddefconfig - Same as oldconfig but sets new symbols to their'
158 @echo ' default value without prompting'
9bcd776d 159 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
6c668505 160 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
0da1d4a0 161 @echo ' tinyconfig - Configure the tiniest possible kernel'
1da177e4 162
2982de69
SR
163# lxdialog stuff
164check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
165
e9e40e14 166# Use recursively expanded variables so we do not call gcc unless
2982de69 167# we really need to do so. (Do not call gcc as part of make mrproper)
9ba95682
AL
168HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
169 -DLOCALE
2982de69 170
1da177e4
LT
171# ===========================================================================
172# Shared Makefile for the various kconfig executables:
173# conf: Used for defconfig, oldconfig and related targets
692d97c3 174# nconf: Used for the nconfig target.
175# Utilizes ncurses
6f26e5e4 176# mconf: Used for the menuconfig target
1da177e4
LT
177# Utilizes the lxdialog package
178# qconf: Used for the xconfig target
092373c2 179# Based on Qt which needs to be installed to compile it
1da177e4 180# gconf: Used for the gconfig target
39c3f1ba 181# Based on GTK+ which needs to be installed to compile it
1da177e4
LT
182# object files used by all kconfig flavours
183
2982de69
SR
184lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
185lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
186
1da177e4 187conf-objs := conf.o zconf.tab.o
692d97c3 188mconf-objs := mconf.o zconf.tab.o $(lxdialog)
189nconf-objs := nconf.o zconf.tab.o nconf.gui.o
3b9fa093 190kxgettext-objs := kxgettext.o zconf.tab.o
f1943049 191qconf-cxxobjs := qconf.o
5a6f8d2b
AL
192qconf-objs := zconf.tab.o
193gconf-objs := gconf.o zconf.tab.o
1da177e4 194
022af62d 195hostprogs-y := conf nconf mconf kxgettext qconf gconf
1da177e4 196
29c83306 197targets += zconf.tab.c zconf.lex.c
5a6f8d2b 198clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
bb3290d9 199clean-files += zconf.tab.c zconf.lex.c gconf.glade.h
1020026f 200clean-files += config.pot linux.pot
1da177e4 201
6e588f6d
SR
202# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
203PHONY += $(obj)/dochecklxdialog
ff85a1a8 204$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
6e588f6d 205$(obj)/dochecklxdialog:
7080e47b 206 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
6e588f6d
SR
207
208always := dochecklxdialog
209
aa1e5ef5
SR
210# Add environment specific flags
211HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
d0fd0428 212HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
70a6a0cb 213
1da177e4 214# generated files seem to need this to find local include files
2f76b358 215HOSTCFLAGS_zconf.lex.o := -I$(src)
1da177e4
LT
216HOSTCFLAGS_zconf.tab.o := -I$(src)
217
5a6f8d2b
AL
218HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
219HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
1da177e4 220
5a6f8d2b 221HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
37193147 222HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
1ea3ad4e 223 -Wno-missing-prototypes
1da177e4 224
7080e47b
AL
225HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
226
544e7e54 227HOSTLOADLIBES_nconf = $(shell \
7285996a
BN
228 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
229 || pkg-config --libs menu panel ncurses 2>/dev/null \
544e7e54 230 || echo "-lmenu -lpanel -lncurses" )
1da177e4
LT
231$(obj)/qconf.o: $(obj)/.tmp_qtcheck
232
022af62d 233ifeq ($(MAKECMDGOALS),xconfig)
b3a5225f 234$(obj)/.tmp_qtcheck: $(src)/Makefile
1da177e4
LT
235-include $(obj)/.tmp_qtcheck
236
092373c2 237# Qt needs some extra effort...
1da177e4 238$(obj)/.tmp_qtcheck:
d1b0dc90 239 @set -e; $(kecho) " CHECK qt"; \
588446a8
TM
240 if pkg-config --exists Qt5Core; then \
241 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
242 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
243 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
244 elif pkg-config --exists QtCore; then \
245 cflags=`pkg-config --cflags QtCore QtGui`; \
246 libs=`pkg-config --libs QtCore QtGui`; \
247 moc=`pkg-config --variable=moc_location QtCore`; \
ab919c06 248 else \
d1b0dc90 249 echo >&2 "*"; \
588446a8
TM
250 echo >&2 "* Could not find Qt via pkg-config."; \
251 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
d1b0dc90
TM
252 echo >&2 "*"; \
253 exit 1; \
b3a5225f
RZ
254 fi; \
255 echo "KC_QT_CFLAGS=$$cflags" > $@; \
256 echo "KC_QT_LIBS=$$libs" >> $@; \
257 echo "KC_QT_MOC=$$moc" >> $@
1da177e4
LT
258endif
259
260$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
261
022af62d 262ifeq ($(MAKECMDGOALS),gconfig)
1da177e4
LT
263-include $(obj)/.tmp_gtkcheck
264
39c3f1ba 265# GTK+ needs some extra effort, too...
1da177e4 266$(obj)/.tmp_gtkcheck:
37193147
AB
267 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
268 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
1da177e4
LT
269 touch $@; \
270 else \
5b580fa6
MM
271 echo >&2 "*"; \
272 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
273 echo >&2 "*"; \
1da177e4
LT
274 false; \
275 fi \
276 else \
5b580fa6
MM
277 echo >&2 "*"; \
278 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
279 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
280 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
281 echo >&2 "*"; \
1da177e4
LT
282 false; \
283 fi
284endif
285
bb3290d9 286$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
1da177e4 287
5a6f8d2b 288$(obj)/qconf.o: $(obj)/qconf.moc
1da177e4 289
ebca026a
YS
290quiet_cmd_moc = MOC $@
291 cmd_moc = $(KC_QT_MOC) -i $< -o $@
292
293$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
294 $(call cmd,moc)
1da177e4 295
39c3f1ba 296# Extract gconf menu items for i18n support
46d26319 297$(obj)/gconf.glade.h: $(obj)/gconf.glade
2d80eb0f 298 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
a24a1b8e 299 $(obj)/gconf.glade